#ifdef QUICKBMS_COMP_ENUM
enum {
    #define QUICKBMS_COMP(X)    COMP_##X,
#endif

#ifdef QUICKBMS_COMP_LIST
typedef struct {
    u8      *name;
    i32     reimport;
} quickbms_comp_list_t;
static /*const*/ quickbms_comp_list_t quickbms_comp_list[] = {
    #define QUICKBMS_COMP(X)    { #X, -1 },
#endif

#ifdef QUICKBMS_COMP_ASSIGN
    #define QUICKBMS_COMP(X)    else if(!stricmp(str, #X)) g_compression_type = COMP_##X;
#endif



//#ifdef QUICKBMS_COMP_ENUM
    QUICKBMS_COMP(NONE)
//#endif

    QUICKBMS_COMP(ZLIB)     // RFC 1950
    QUICKBMS_COMP(DEFLATE)  // RFC 1951
    QUICKBMS_COMP(LZO1)
    QUICKBMS_COMP(LZO1A)
    QUICKBMS_COMP(LZO1B)
    QUICKBMS_COMP(LZO1C)
    QUICKBMS_COMP(LZO1F)
    QUICKBMS_COMP(LZO1X)
    QUICKBMS_COMP(LZO1Y)
    QUICKBMS_COMP(LZO1Z)
    QUICKBMS_COMP(LZO2A)
    QUICKBMS_COMP(LZSS)
    QUICKBMS_COMP(LZX)
    QUICKBMS_COMP(GZIP)
    QUICKBMS_COMP(EXPLODE)
    QUICKBMS_COMP(LZMA)
    QUICKBMS_COMP(LZMA_86HEAD)
    QUICKBMS_COMP(LZMA_86DEC)
    QUICKBMS_COMP(LZMA_86DECHEAD)
    QUICKBMS_COMP(LZMA_EFS)
    QUICKBMS_COMP(BZIP2)
    QUICKBMS_COMP(XMEMLZX)
    QUICKBMS_COMP(HEX)
    QUICKBMS_COMP(BASE64)
    QUICKBMS_COMP(UUENCODE)
    QUICKBMS_COMP(ASCII85)
    QUICKBMS_COMP(YENC)
    QUICKBMS_COMP(UNLZW)
    QUICKBMS_COMP(UNLZWX)
    QUICKBMS_COMP(LZXCAB)
    QUICKBMS_COMP(LZXCHM)
    QUICKBMS_COMP(RLEW)
    QUICKBMS_COMP(LZJB)
    QUICKBMS_COMP(SFL_BLOCK)
    QUICKBMS_COMP(SFL_RLE)
    QUICKBMS_COMP(SFL_NULLS)
    QUICKBMS_COMP(SFL_BITS)
    QUICKBMS_COMP(LZMA2)
    QUICKBMS_COMP(LZMA2_86HEAD)
    QUICKBMS_COMP(LZMA2_86DEC)
    QUICKBMS_COMP(LZMA2_86DECHEAD)
    QUICKBMS_COMP(NRV2b)
    QUICKBMS_COMP(NRV2d)
    QUICKBMS_COMP(NRV2e)
    QUICKBMS_COMP(HUFFBOH)
    QUICKBMS_COMP(UNCOMPRESS)
    QUICKBMS_COMP(DMC)
    QUICKBMS_COMP(LZH)
    QUICKBMS_COMP(LZARI)
    QUICKBMS_COMP(TONY)
    QUICKBMS_COMP(RLE7)
    QUICKBMS_COMP(RLE0)
    QUICKBMS_COMP(RLE)
    QUICKBMS_COMP(RLEA)
    QUICKBMS_COMP(BPE)
    QUICKBMS_COMP(QUICKLZ)
    QUICKBMS_COMP(Q3HUFF)
    QUICKBMS_COMP(UNMENG)
    QUICKBMS_COMP(LZ2K)
    QUICKBMS_COMP(DARKSECTOR)
    QUICKBMS_COMP(MSZH)
    QUICKBMS_COMP(UN49G)
    QUICKBMS_COMP(UNTHANDOR)
    QUICKBMS_COMP(DOOMHUFF)
    QUICKBMS_COMP(APLIB)
    QUICKBMS_COMP(TZAR_LZSS)
    QUICKBMS_COMP(LZF)
    QUICKBMS_COMP(CLZ77)
    QUICKBMS_COMP(LZRW1)
    QUICKBMS_COMP(DHUFF)
    QUICKBMS_COMP(FIN)
    QUICKBMS_COMP(LZAH)
    QUICKBMS_COMP(LZH12)
    QUICKBMS_COMP(LZH13)
    QUICKBMS_COMP(GRZIP)
    QUICKBMS_COMP(CKRLE)
    QUICKBMS_COMP(QUAD)
    QUICKBMS_COMP(BALZ)
    QUICKBMS_COMP(DEFLATE64)
    QUICKBMS_COMP(SHRINK)
    QUICKBMS_COMP(PPMDI)
    QUICKBMS_COMP(MULTIBASE)
    QUICKBMS_COMP(BRIEFLZ)
    QUICKBMS_COMP(PAQ6)
    QUICKBMS_COMP(SHCODEC)
    QUICKBMS_COMP(HSTEST1)
    QUICKBMS_COMP(HSTEST2)
    QUICKBMS_COMP(SIXPACK)
    QUICKBMS_COMP(ASHFORD)
    QUICKBMS_COMP(JCALG)
    QUICKBMS_COMP(JAM)
    QUICKBMS_COMP(LZHLIB)
    QUICKBMS_COMP(SRANK)
    QUICKBMS_COMP(ZZIP)
    QUICKBMS_COMP(SCPACK)
    QUICKBMS_COMP(RLE3)
    QUICKBMS_COMP(BPE2)
    QUICKBMS_COMP(BCL_HUF)
    QUICKBMS_COMP(BCL_LZ)
    QUICKBMS_COMP(BCL_RICE)
    QUICKBMS_COMP(BCL_RLE)
    QUICKBMS_COMP(BCL_SF)
    QUICKBMS_COMP(SCZ)
    QUICKBMS_COMP(SZIP)
    QUICKBMS_COMP(PPMDI_RAW)
    QUICKBMS_COMP(PPMDG)
    QUICKBMS_COMP(PPMDG_RAW)
    QUICKBMS_COMP(PPMDJ)
    QUICKBMS_COMP(PPMDJ_RAW)
    QUICKBMS_COMP(SR3C)
    QUICKBMS_COMP(HUFFMANLIB)
    QUICKBMS_COMP(SFASTPACKER)
    QUICKBMS_COMP(SFASTPACKER2)
    QUICKBMS_COMP(DK2)
    QUICKBMS_COMP(LZ77WII)
    QUICKBMS_COMP(LZ77WII_RAW10)
    QUICKBMS_COMP(DARKSTONE)
    QUICKBMS_COMP(SFL_BLOCK_CHUNKED)
    QUICKBMS_COMP(YUKE_BPE)
    QUICKBMS_COMP(STALKER_LZA)
    QUICKBMS_COMP(PRS_8ING)
    QUICKBMS_COMP(PUYO_CNX)
    QUICKBMS_COMP(PUYO_CXLZ)
    QUICKBMS_COMP(PUYO_LZ00)
    QUICKBMS_COMP(PUYO_LZ01)
    QUICKBMS_COMP(PUYO_LZSS)
    QUICKBMS_COMP(PUYO_ONZ)
    QUICKBMS_COMP(PUYO_PRS)
    QUICKBMS_COMP(FALCOM)
    QUICKBMS_COMP(CPK)
    QUICKBMS_COMP(BZIP2_FILE)
    QUICKBMS_COMP(LZ77WII_RAW11)
    QUICKBMS_COMP(LZ77WII_RAW30)
    QUICKBMS_COMP(LZ77WII_RAW20)
    QUICKBMS_COMP(PGLZ)
    QUICKBMS_COMP(SLZ)
    QUICKBMS_COMP(SLZ_01)
    QUICKBMS_COMP(SLZ_02)
    QUICKBMS_COMP(LZHL)
    QUICKBMS_COMP(D3101)
    QUICKBMS_COMP(SQUEEZE)
    QUICKBMS_COMP(LZRW3)
    QUICKBMS_COMP(TDCB_ahuff)
    QUICKBMS_COMP(TDCB_arith)
    QUICKBMS_COMP(TDCB_arith1)
    QUICKBMS_COMP(TDCB_arith1e)
    QUICKBMS_COMP(TDCB_arithn)
    QUICKBMS_COMP(TDCB_compand)
    QUICKBMS_COMP(TDCB_huff)
    QUICKBMS_COMP(TDCB_lzss)
    QUICKBMS_COMP(TDCB_lzw12)
    QUICKBMS_COMP(TDCB_lzw15v)
    QUICKBMS_COMP(TDCB_silence)
    QUICKBMS_COMP(RDC)
    QUICKBMS_COMP(ILZR)
    QUICKBMS_COMP(DMC2)
    QUICKBMS_COMP(diffcomp)
    QUICKBMS_COMP(LZR)
    QUICKBMS_COMP(LZS)
    QUICKBMS_COMP(LZS_BIG)
    QUICKBMS_COMP(COPY)
    QUICKBMS_COMP(MOHLZSS)
    QUICKBMS_COMP(MOHRLE)
    QUICKBMS_COMP(YAZ0)
    QUICKBMS_COMP(BYTE2HEX)
    QUICKBMS_COMP(UN434A)
    QUICKBMS_COMP(UNZIP_DYNAMIC)
    QUICKBMS_COMP(XXENCODE)
    QUICKBMS_COMP(GZPACK)
    QUICKBMS_COMP(ZLIB_NOERROR)
    QUICKBMS_COMP(DEFLATE_NOERROR)
    QUICKBMS_COMP(PPMDH)
    QUICKBMS_COMP(PPMDH_RAW)
    QUICKBMS_COMP(RNC)
    QUICKBMS_COMP(RNC_RAW)
    QUICKBMS_COMP(FITD)
    QUICKBMS_COMP(KENS_Nemesis)
    QUICKBMS_COMP(KENS_Kosinski)
    QUICKBMS_COMP(KENS_Kosinski_moduled)
    QUICKBMS_COMP(KENS_Enigma)
    QUICKBMS_COMP(KENS_Saxman)
    QUICKBMS_COMP(DRAGONBALLZ)
    QUICKBMS_COMP(NITROSDK)
    QUICKBMS_COMP(ZDAEMON)
    QUICKBMS_COMP(SKULLTAG)
    QUICKBMS_COMP(MSF)
    QUICKBMS_COMP(STARGUNNER)
    QUICKBMS_COMP(NTCOMPRESS)
    QUICKBMS_COMP(CRLE)
    QUICKBMS_COMP(CTW)
    QUICKBMS_COMP(DACT_DELTA)
    QUICKBMS_COMP(DACT_MZLIB2)
    QUICKBMS_COMP(DACT_MZLIB)
    QUICKBMS_COMP(DACT_RLE)
    QUICKBMS_COMP(DACT_SNIBBLE)
    QUICKBMS_COMP(DACT_TEXT)
    QUICKBMS_COMP(DACT_TEXTRLE)
    QUICKBMS_COMP(EXECUTE)
    QUICKBMS_COMP(LZ77_0)
    QUICKBMS_COMP(LZBSS)
    QUICKBMS_COMP(BPAQ0)
    QUICKBMS_COMP(LZPX)
    QUICKBMS_COMP(MAR_RLE)
    QUICKBMS_COMP(GDCM_RLE)
    QUICKBMS_COMP(LZMAT)
    QUICKBMS_COMP(DICT)
    QUICKBMS_COMP(REP)
    QUICKBMS_COMP(LZP)
    QUICKBMS_COMP(ELIAS_DELTA)
    QUICKBMS_COMP(ELIAS_GAMMA)
    QUICKBMS_COMP(ELIAS_OMEGA)
    QUICKBMS_COMP(PACKBITS)
    QUICKBMS_COMP(DARKSECTOR_NOCHUNKS)
    QUICKBMS_COMP(ENET)
    QUICKBMS_COMP(EDUKE32)
    QUICKBMS_COMP(XU4_RLE)
    QUICKBMS_COMP(RVL)
    QUICKBMS_COMP(LZFU)
    QUICKBMS_COMP(LZFU_RAW)
    QUICKBMS_COMP(XU4_LZW)
    QUICKBMS_COMP(HE3)
    QUICKBMS_COMP(IRIS)
    QUICKBMS_COMP(IRIS_HUFFMAN)
    QUICKBMS_COMP(IRIS_UO_HUFFMAN)
    QUICKBMS_COMP(NTFS)
    QUICKBMS_COMP(PDB)
    QUICKBMS_COMP(COMPRLIB_SPREAD)
    QUICKBMS_COMP(COMPRLIB_RLE1)
    QUICKBMS_COMP(COMPRLIB_RLE2)
    QUICKBMS_COMP(COMPRLIB_RLE3)
    QUICKBMS_COMP(COMPRLIB_RLE4)
    QUICKBMS_COMP(COMPRLIB_ARITH)
    QUICKBMS_COMP(COMPRLIB_SPLAY)
    QUICKBMS_COMP(CABEXTRACT)
    QUICKBMS_COMP(MRCI)
    QUICKBMS_COMP(HD2_01)
    QUICKBMS_COMP(HD2_08)
    QUICKBMS_COMP(HD2_01raw)
    QUICKBMS_COMP(RTL_LZNT1)
    QUICKBMS_COMP(RTL_XPRESS)
    QUICKBMS_COMP(RTL_XPRESS_HUFF)
    QUICKBMS_COMP(PRS)
    QUICKBMS_COMP(SEGA_LZ77)
    QUICKBMS_COMP(SAINT_SEYA)
    QUICKBMS_COMP(NTCOMPRESS30)
    QUICKBMS_COMP(NTCOMPRESS40)
    QUICKBMS_COMP(SLZ_03)
    QUICKBMS_COMP(YAKUZA)
    QUICKBMS_COMP(LZ4)
    QUICKBMS_COMP(SNAPPY)
    QUICKBMS_COMP(LUNAR_LZ1)
    QUICKBMS_COMP(LUNAR_LZ2)
    QUICKBMS_COMP(LUNAR_LZ3)
    QUICKBMS_COMP(LUNAR_LZ4)
    QUICKBMS_COMP(LUNAR_LZ5)
    QUICKBMS_COMP(LUNAR_LZ6)
    QUICKBMS_COMP(LUNAR_LZ7)
    QUICKBMS_COMP(LUNAR_LZ8)
    QUICKBMS_COMP(LUNAR_LZ9)
    QUICKBMS_COMP(LUNAR_LZ10)
    QUICKBMS_COMP(LUNAR_LZ11)
    QUICKBMS_COMP(LUNAR_LZ12)
    QUICKBMS_COMP(LUNAR_LZ13)
    QUICKBMS_COMP(LUNAR_LZ14)
    QUICKBMS_COMP(LUNAR_LZ15)
    QUICKBMS_COMP(LUNAR_LZ16)
    QUICKBMS_COMP(LUNAR_RLE1)
    QUICKBMS_COMP(LUNAR_RLE2)
    QUICKBMS_COMP(LUNAR_RLE3)
    QUICKBMS_COMP(LUNAR_RLE4)
    QUICKBMS_COMP(GOLDENSUN)
    QUICKBMS_COMP(LUMINOUSARC)
    QUICKBMS_COMP(LZV1)
    QUICKBMS_COMP(FASTLZAH)
    QUICKBMS_COMP(ZAX)
    QUICKBMS_COMP(SHRINKER)
    QUICKBMS_COMP(MMINI_HUFFMAN)
    QUICKBMS_COMP(MMINI_LZ1)
    QUICKBMS_COMP(MMINI)
    QUICKBMS_COMP(CLZW)
    QUICKBMS_COMP(LZHAM)
    QUICKBMS_COMP(LPAQ8)
    QUICKBMS_COMP(SEGA_LZS2)
    QUICKBMS_COMP(CALLDLL)
    QUICKBMS_COMP(WOLF)
    QUICKBMS_COMP(COREONLINE)
    QUICKBMS_COMP(MSZIP)
    QUICKBMS_COMP(QTM)
    QUICKBMS_COMP(MSLZSS)
    QUICKBMS_COMP(MSLZSS1)
    QUICKBMS_COMP(MSLZSS2)
    QUICKBMS_COMP(KWAJ)
    QUICKBMS_COMP(LZLIB)
    QUICKBMS_COMP(DFLT)
    QUICKBMS_COMP(LZMA_DYNAMIC)
    QUICKBMS_COMP(LZMA2_DYNAMIC)
    QUICKBMS_COMP(LZMA2_EFS)
    QUICKBMS_COMP(LZXCAB_DELTA)
    QUICKBMS_COMP(LZXCHM_DELTA)
    QUICKBMS_COMP(FFCE)
    QUICKBMS_COMP(SCUMMVM4)
    QUICKBMS_COMP(SCUMMVM5)
    QUICKBMS_COMP(SCUMMVM6)
    QUICKBMS_COMP(SCUMMVM7)
    QUICKBMS_COMP(SCUMMVM8)
    QUICKBMS_COMP(SCUMMVM9)
    QUICKBMS_COMP(SCUMMVM10)
    QUICKBMS_COMP(SCUMMVM11)
    QUICKBMS_COMP(SCUMMVM12)
    QUICKBMS_COMP(SCUMMVM13)
    QUICKBMS_COMP(SCUMMVM14)
    QUICKBMS_COMP(SCUMMVM15)
    QUICKBMS_COMP(SCUMMVM16)
    QUICKBMS_COMP(SCUMMVM17)
    QUICKBMS_COMP(SCUMMVM18)
    QUICKBMS_COMP(SCUMMVM19)
    QUICKBMS_COMP(SCUMMVM20)
    QUICKBMS_COMP(SCUMMVM21)
    QUICKBMS_COMP(SCUMMVM22)
    QUICKBMS_COMP(SCUMMVM23)
    QUICKBMS_COMP(SCUMMVM24)
    QUICKBMS_COMP(SCUMMVM25)
    QUICKBMS_COMP(SCUMMVM26)
    QUICKBMS_COMP(SCUMMVM27)
    QUICKBMS_COMP(SCUMMVM28)
    QUICKBMS_COMP(SCUMMVM29)
    QUICKBMS_COMP(SCUMMVM30)
    QUICKBMS_COMP(SCUMMVM31)
    QUICKBMS_COMP(SCUMMVM32)
    QUICKBMS_COMP(SCUMMVM33)
    QUICKBMS_COMP(SCUMMVM34)
    QUICKBMS_COMP(SCUMMVM35)
    QUICKBMS_COMP(SCUMMVM36)
    QUICKBMS_COMP(SCUMMVM37)
    QUICKBMS_COMP(SCUMMVM38)
    QUICKBMS_COMP(SCUMMVM39)
    QUICKBMS_COMP(SCUMMVM40)
    QUICKBMS_COMP(SCUMMVM41)
    QUICKBMS_COMP(SCUMMVM42)
    QUICKBMS_COMP(SCUMMVM43)
    QUICKBMS_COMP(SCUMMVM44)
    QUICKBMS_COMP(SCUMMVM45)
    QUICKBMS_COMP(SCUMMVM46)
    QUICKBMS_COMP(SCUMMVM47)
    QUICKBMS_COMP(SCUMMVM48)
    QUICKBMS_COMP(SCUMMVM49)
    QUICKBMS_COMP(SCUMMVM50)
    QUICKBMS_COMP(SCUMMVM51)
    QUICKBMS_COMP(SCUMMVM52)
    QUICKBMS_COMP(SCUMMVM53)
    QUICKBMS_COMP(LZS_UNZIP)
    QUICKBMS_COMP(LEGEND_OF_MANA)
    QUICKBMS_COMP(DIZZY)
    QUICKBMS_COMP(EDL1)
    QUICKBMS_COMP(EDL2)
    QUICKBMS_COMP(DUNGEON_KID)
    QUICKBMS_COMP(LUNAR_LZ17)
    QUICKBMS_COMP(LUNAR_LZ18)
    QUICKBMS_COMP(FRONTMISSION2)
    QUICKBMS_COMP(RLEINC1)
    QUICKBMS_COMP(RLEINC2)
    QUICKBMS_COMP(EVOLUTION)
    QUICKBMS_COMP(PUYO_LZ10)
    QUICKBMS_COMP(PUYO_LZ11)
    QUICKBMS_COMP(NISLZS)
    QUICKBMS_COMP(UNKNOWN1)
    QUICKBMS_COMP(UNKNOWN2)
    QUICKBMS_COMP(UNKNOWN3)
    QUICKBMS_COMP(UNKNOWN4)
    QUICKBMS_COMP(UNKNOWN5)
    QUICKBMS_COMP(UNKNOWN6)
    QUICKBMS_COMP(UNKNOWN7)
    QUICKBMS_COMP(UNKNOWN8)
    QUICKBMS_COMP(UNKNOWN9)
    QUICKBMS_COMP(UNKNOWN10)
    QUICKBMS_COMP(UNKNOWN11)
    QUICKBMS_COMP(UNKNOWN12)
    QUICKBMS_COMP(UNKNOWN13)
    QUICKBMS_COMP(UNKNOWN14)
    QUICKBMS_COMP(UNKNOWN15)
    QUICKBMS_COMP(UNKNOWN16)
    QUICKBMS_COMP(UNKNOWN17)
    QUICKBMS_COMP(UNKNOWN18)
    QUICKBMS_COMP(UNKNOWN19)
    QUICKBMS_COMP(BLACKDESERT)
    QUICKBMS_COMP(BLACKDESERT_RAW)
    QUICKBMS_COMP(PUCRUNCH)
    QUICKBMS_COMP(ZPAQ)
    QUICKBMS_COMP(ZYXEL_LZS)
    QUICKBMS_COMP(BLOSC)
    QUICKBMS_COMP(GIPFELI)
    QUICKBMS_COMP(CRUSH)
    QUICKBMS_COMP(YAPPY)
    QUICKBMS_COMP(LZG)
    QUICKBMS_COMP(DOBOZ)
    QUICKBMS_COMP(TORNADO)
    QUICKBMS_COMP(XPKSQSH)
    QUICKBMS_COMP(AMIGA_UNSQUASH)
    QUICKBMS_COMP(AMIGA_BYTEKILLER)
    QUICKBMS_COMP(AMIGA_FLASHSPEED)
    QUICKBMS_COMP(AMIGA_IAMICE)
    QUICKBMS_COMP(AMIGA_IAMATM)
    QUICKBMS_COMP(AMIGA_ISC1P)
    QUICKBMS_COMP(AMIGA_ISC2P)
    QUICKBMS_COMP(AMIGA_ISC3P)
    QUICKBMS_COMP(AMIGA_UPCOMP)
    QUICKBMS_COMP(AMIGA_UPHD)
    QUICKBMS_COMP(AMIGA_BYTEKILLER3)
    QUICKBMS_COMP(AMIGA_BYTEKILLER2)
    QUICKBMS_COMP(AMIGA_CRUNCHMANIA17b)
    QUICKBMS_COMP(AMIGA_POWERPACKER)
    QUICKBMS_COMP(AMIGA_STONECRACKER2)
    QUICKBMS_COMP(AMIGA_STONECRACKER3)
    QUICKBMS_COMP(AMIGA_STONECRACKER4)
    QUICKBMS_COMP(AMIGA_CRUNCHMASTER)
    QUICKBMS_COMP(AMIGA_CRUNCHMANIA)
    QUICKBMS_COMP(AMIGA_CRUNCHMANIAh)
    QUICKBMS_COMP(AMIGA_CRUNCHOMATIC)
    QUICKBMS_COMP(AMIGA_DISCOVERY)
    QUICKBMS_COMP(AMIGA_LIGHTPACK)
    QUICKBMS_COMP(AMIGA_MASTERCRUNCHER)
    QUICKBMS_COMP(AMIGA_MAXPACKER)
    QUICKBMS_COMP(AMIGA_MEGACRUNCHER)
    QUICKBMS_COMP(AMIGA_PACKIT)
    QUICKBMS_COMP(AMIGA_SPIKECRUNCHER)
    QUICKBMS_COMP(AMIGA_TETRAPACK)
    QUICKBMS_COMP(AMIGA_TIMEDECRUNCH)
    QUICKBMS_COMP(AMIGA_TRYIT)
    QUICKBMS_COMP(AMIGA_TUC)
    QUICKBMS_COMP(AMIGA_TURBOSQUEEZER61)
    QUICKBMS_COMP(AMIGA_TURBOSQUEEZER80)
    QUICKBMS_COMP(AMIGA_TURTLESMASHER)
    QUICKBMS_COMP(AMIGA_DMS)
    QUICKBMS_COMP(AMIGA_PACKFIRE)
    QUICKBMS_COMP(ALBA_BPE)
    QUICKBMS_COMP(ALBA_BPE2)
    QUICKBMS_COMP(FLZP)
    QUICKBMS_COMP(SR2)
    QUICKBMS_COMP(SR3)
    QUICKBMS_COMP(BPE2v3)
    QUICKBMS_COMP(BPE_ALT1)
    QUICKBMS_COMP(BPE_ALT2)
    QUICKBMS_COMP(CBPE)
    QUICKBMS_COMP(SCPACK0)
    QUICKBMS_COMP(LZMA_0)
    QUICKBMS_COMP(LZMA_86HEAD0)
    QUICKBMS_COMP(LZMA_86DEC0)
    QUICKBMS_COMP(LZMA_86DECHEAD0)
    QUICKBMS_COMP(LZMA_EFS0)
    QUICKBMS_COMP(LZMA2_0)
    QUICKBMS_COMP(LZMA2_86HEAD0)
    QUICKBMS_COMP(LZMA2_86DEC0)
    QUICKBMS_COMP(LZMA2_86DECHEAD0)
    QUICKBMS_COMP(LZMA2_EFS0)
    QUICKBMS_COMP(LZOVL)
    QUICKBMS_COMP(NITROSDK_DIFF8)
    QUICKBMS_COMP(NITROSDK_DIFF16)
    QUICKBMS_COMP(NITROSDK_HUFF8)
    QUICKBMS_COMP(NITROSDK_HUFF16)
    QUICKBMS_COMP(NITROSDK_LZ)
    QUICKBMS_COMP(NITROSDK_RL)
    QUICKBMS_COMP(QCMP)
    QUICKBMS_COMP(SPARSE)
    QUICKBMS_COMP(STORMHUFF)
    QUICKBMS_COMP(GZIP_STRICT)
    QUICKBMS_COMP(CT_HughesTransform)
    QUICKBMS_COMP(CT_LZ77)
    QUICKBMS_COMP(CT_ELSCoder)
    QUICKBMS_COMP(CT_RefPack)
    QUICKBMS_COMP(QFS)
    QUICKBMS_COMP(PXP)
    QUICKBMS_COMP(BOH)
    QUICKBMS_COMP(GRC)
    QUICKBMS_COMP(ZEN)
    QUICKBMS_COMP(LZHUFXR)
    QUICKBMS_COMP(FSE)
    QUICKBMS_COMP(FSE_RLE)
    QUICKBMS_COMP(ZSTD)
    QUICKBMS_COMP(CSC)
    QUICKBMS_COMP(RNCb)
    QUICKBMS_COMP(RNCb_RAW)
    QUICKBMS_COMP(RNCc_RAW)
    QUICKBMS_COMP(AZO)
    QUICKBMS_COMP(PP20)
    QUICKBMS_COMP(DS_BLZ)
    QUICKBMS_COMP(DS_HUF)
    QUICKBMS_COMP(DS_LZE)
    QUICKBMS_COMP(DS_LZS)
    QUICKBMS_COMP(DS_LZX)
    QUICKBMS_COMP(DS_RLE)
    QUICKBMS_COMP(FAB)
    QUICKBMS_COMP(LZ4F)
    QUICKBMS_COMP(PCLZFG)
    QUICKBMS_COMP(LZOO)
    QUICKBMS_COMP(DELZC)
    QUICKBMS_COMP(DEHUFF)
    QUICKBMS_COMP(HEATSHRINK)
    QUICKBMS_COMP(NEPTUNIA)
    QUICKBMS_COMP(SMAZ)
    QUICKBMS_COMP(LZFX)
    QUICKBMS_COMP(PITHY)
    QUICKBMS_COMP(ZLING)
    QUICKBMS_COMP(DENSITY)
    QUICKBMS_COMP(BROTLI)
    QUICKBMS_COMP(RLE32)
    QUICKBMS_COMP(RLE35)
    QUICKBMS_COMP(BSC)
    QUICKBMS_COMP(SHOCO)
    QUICKBMS_COMP(WFLZ)
    QUICKBMS_COMP(FASTARI)
    QUICKBMS_COMP(RLE_ORCOM)
    QUICKBMS_COMP(DICKY)
    QUICKBMS_COMP(SQUISH)
    QUICKBMS_COMP(LZNT1)
    QUICKBMS_COMP(XPRESS)
    QUICKBMS_COMP(XPRESS_HUFF)
    QUICKBMS_COMP(LZJODY)
    QUICKBMS_COMP(TRLE)
    QUICKBMS_COMP(SRLE)
    QUICKBMS_COMP(MRLE)
    QUICKBMS_COMP(LUNAR_LZ19)
    QUICKBMS_COMP(JCH)
    QUICKBMS_COMP(LZRW1KH)
    QUICKBMS_COMP(LZSS0)
    QUICKBMS_COMP(LHA_lz5)
    QUICKBMS_COMP(LHA_lzs)
    QUICKBMS_COMP(LHA_lh1)
    QUICKBMS_COMP(LHA_lh4)
    QUICKBMS_COMP(LHA_lh5)
    QUICKBMS_COMP(LHA_lh6)
    QUICKBMS_COMP(LHA_lh7)
    QUICKBMS_COMP(LHA_lhx)
    QUICKBMS_COMP(LHA_pm1)
    QUICKBMS_COMP(LHA_pm2)
    QUICKBMS_COMP(SQX1)
    QUICKBMS_COMP(MDIP_ARAD)
    QUICKBMS_COMP(MDIP_ARST)
    QUICKBMS_COMP(MDIP_DELTA)
    QUICKBMS_COMP(MDIP_FREQ)
    QUICKBMS_COMP(MDIP_HUFFMAN)
    QUICKBMS_COMP(MDIP_CANONICAL)
    QUICKBMS_COMP(MDIP_LZSS)
    QUICKBMS_COMP(MDIP_LZW)
    QUICKBMS_COMP(MDIP_RICE)
    QUICKBMS_COMP(MDIP_RLE)
    QUICKBMS_COMP(MDIP_VPACKBITS)
    QUICKBMS_COMP(BIZARRE)
    QUICKBMS_COMP(BIZARRE_SKIP)
    QUICKBMS_COMP(LZSSX)
    QUICKBMS_COMP(ASH)
    QUICKBMS_COMP(YAY0)
    QUICKBMS_COMP(DSTACKER)
    QUICKBMS_COMP(DSTACKER_SD3)
    QUICKBMS_COMP(DSTACKER_SD4)
    QUICKBMS_COMP(DBLSPACE)
    QUICKBMS_COMP(DBLSPACE_JM)
    QUICKBMS_COMP(XREFPACK)
    QUICKBMS_COMP(XREFPACK0)
    QUICKBMS_COMP(QCMP2)
    QUICKBMS_COMP(DEFLATEX)
    QUICKBMS_COMP(ZLIBX)
    QUICKBMS_COMP(LZRW1a)
    QUICKBMS_COMP(LZRW2)
    QUICKBMS_COMP(LZRW3a)
    QUICKBMS_COMP(LZRW5)
    QUICKBMS_COMP(LEGO_IXS)
    QUICKBMS_COMP(MCOMP)
    QUICKBMS_COMP(MCOMP0)
    QUICKBMS_COMP(MCOMP1)
    QUICKBMS_COMP(MCOMP2)
    QUICKBMS_COMP(MCOMP3)
    QUICKBMS_COMP(MCOMP4)
    QUICKBMS_COMP(MCOMP5)
    QUICKBMS_COMP(MCOMP6)
    QUICKBMS_COMP(MCOMP7)
    QUICKBMS_COMP(MCOMP8)
    QUICKBMS_COMP(MCOMP9)
    QUICKBMS_COMP(MCOMP10)
    QUICKBMS_COMP(MCOMP13)
    QUICKBMS_COMP(MCOMP14)
    QUICKBMS_COMP(MCOMP15)
    QUICKBMS_COMP(MCOMP16)
    QUICKBMS_COMP(MCOMP17)
    QUICKBMS_COMP(IROLZ)
    QUICKBMS_COMP(IROLZ2)
    QUICKBMS_COMP(UCLPACK)
    QUICKBMS_COMP(ACE)
    QUICKBMS_COMP(EA_COMP)
    QUICKBMS_COMP(EA_HUFF)
    QUICKBMS_COMP(EA_JDLZ)
    QUICKBMS_COMP(TORNADO_BYTE)
    QUICKBMS_COMP(TORNADO_BIT)
    QUICKBMS_COMP(TORNADO_HUF)
    QUICKBMS_COMP(TORNADO_ARI)
    QUICKBMS_COMP(LBALZSS1)
    QUICKBMS_COMP(LBALZSS2)
    QUICKBMS_COMP(DBPF)
    QUICKBMS_COMP(TITUS_LZW)
    QUICKBMS_COMP(TITUS_HUFFMAN)
    QUICKBMS_COMP(KB_LZW)
    QUICKBMS_COMP(KB_DOSLZW)
    QUICKBMS_COMP(CARMACK)
    QUICKBMS_COMP(MBASH)
    QUICKBMS_COMP(DDAVE)
    QUICKBMS_COMP(GOT)
    QUICKBMS_COMP(SKYROADS)
    QUICKBMS_COMP(ZONE66)
    QUICKBMS_COMP(EXEPACK)
    QUICKBMS_COMP(DE_LZW)
    QUICKBMS_COMP(JJRLE)
    QUICKBMS_COMP(K13RLE)
    QUICKBMS_COMP(SFRLC)
    QUICKBMS_COMP(WESTWOOD1)
    QUICKBMS_COMP(WESTWOOD3)
    QUICKBMS_COMP(WESTWOOD3b)
    QUICKBMS_COMP(WESTWOOD40)
    QUICKBMS_COMP(WESTWOOD80)
    QUICKBMS_COMP(PKWARE_DCL)
    QUICKBMS_COMP(TERSE)
    QUICKBMS_COMP(TERSE_SPACK_RAW)
    QUICKBMS_COMP(TERSE_PACK_RAW)
    QUICKBMS_COMP(REDUCE1)
    QUICKBMS_COMP(REDUCE2)
    QUICKBMS_COMP(REDUCE3)
    QUICKBMS_COMP(REDUCE4)
    QUICKBMS_COMP(LZW_ENGINE)
    QUICKBMS_COMP(LZW_BASH)
    QUICKBMS_COMP(LZW_EPFS)
    QUICKBMS_COMP(LZW_STELLAR7)
    QUICKBMS_COMP(ULTIMA6)
    QUICKBMS_COMP(LZ5)
    QUICKBMS_COMP(LZ5F)
    QUICKBMS_COMP(YALZ77)
    QUICKBMS_COMP(LZKN1)
    QUICKBMS_COMP(LZKN2)
    QUICKBMS_COMP(LZKN3)
    QUICKBMS_COMP(TFLZSS)
    QUICKBMS_COMP(SYNLZ1)
    QUICKBMS_COMP(SYNLZ1b)
    QUICKBMS_COMP(SYNLZ1partial)
    QUICKBMS_COMP(SYNLZ2)
    QUICKBMS_COMP(PPMZ2)
    QUICKBMS_COMP(OPENDARK)
    QUICKBMS_COMP(DSLZSS)
    QUICKBMS_COMP(KOF)
    QUICKBMS_COMP(KOF1)
    QUICKBMS_COMP(RFPK)
    QUICKBMS_COMP(WP16)
    QUICKBMS_COMP(LZ4_STREAM)
    QUICKBMS_COMP(OODLE)
    QUICKBMS_COMP(OODLE_LZH)
    QUICKBMS_COMP(OODLE_LZHLW)
    QUICKBMS_COMP(OODLE_LZNIB)
    QUICKBMS_COMP(OODLE_LZB16)
    QUICKBMS_COMP(OODLE_LZBLW)
    QUICKBMS_COMP(OODLE_LZNA)
    QUICKBMS_COMP(OODLE_BitKnit)
    QUICKBMS_COMP(OODLE_LZA)
    QUICKBMS_COMP(OODLE_LZQ1)
    QUICKBMS_COMP(OODLE_LZNIB2)
    QUICKBMS_COMP(SEGS)
    QUICKBMS_COMP(OODLE_Selkie)
    QUICKBMS_COMP(OODLE_Akkorokamui)
    QUICKBMS_COMP(ALZ)
    QUICKBMS_COMP(REVELATION_ONLINE)
    QUICKBMS_COMP(PS_LZ77)
    QUICKBMS_COMP(LZFSE)
    QUICKBMS_COMP(ZLE)
    QUICKBMS_COMP(KOF2)
    QUICKBMS_COMP(KOF3)
    QUICKBMS_COMP(HSQ)
    QUICKBMS_COMP(FACT5LZ)
    QUICKBMS_COMP(LZCAPTSU)
    QUICKBMS_COMP(TF3_RLE)
    QUICKBMS_COMP(WINIMPLODE)
    QUICKBMS_COMP(DZIP)
    QUICKBMS_COMP(DZIP_COMBUF)
    QUICKBMS_COMP(LBALZSS1X)
    QUICKBMS_COMP(LBALZSS2X)
    QUICKBMS_COMP(GHIREN)
    QUICKBMS_COMP(FALCOM_DIN)
    QUICKBMS_COMP(FALCOM_DIN1)
    QUICKBMS_COMP(FALCOM_DIN0)
    QUICKBMS_COMP(FALCOM_DINX)
    QUICKBMS_COMP(GLZA)
    QUICKBMS_COMP(M99CODER)
    QUICKBMS_COMP(LZ4X)
    QUICKBMS_COMP(TAIKO)
    QUICKBMS_COMP(LZ77EA_970)
    QUICKBMS_COMP(DRV3_SRD)
    QUICKBMS_COMP(RECET)
    QUICKBMS_COMP(LIZARD)
    QUICKBMS_COMP(MICROVISION)
    QUICKBMS_COMP(DR12AE)
    QUICKBMS_COMP(MSPACK)
    QUICKBMS_COMP(KONAMIAC)
    QUICKBMS_COMP(WOLF0)
    QUICKBMS_COMP(ARTSTATION)
    QUICKBMS_COMP(LEVEL5)
    QUICKBMS_COMP(ZENPXP)
    QUICKBMS_COMP(ZENPXP1)
    QUICKBMS_COMP(ZENPXP2)
    QUICKBMS_COMP(ZENPXP34)
    QUICKBMS_COMP(ZENPXPde)
    QUICKBMS_COMP(LIBLZS)
    QUICKBMS_COMP(SHREK)
    QUICKBMS_COMP(EA_MADDEN)
    QUICKBMS_COMP(NVCACHE)
    QUICKBMS_COMP(DE_HTML)
    QUICKBMS_COMP(HTML_EASY)
    QUICKBMS_COMP(JSON_VIEWER)
    QUICKBMS_COMP(XML_JSON_PARSER)
    QUICKBMS_COMP(OodleNetwork1UDP_State_Uncompact)
    QUICKBMS_COMP(OodleNetwork1_Shared_SetWindow)
    QUICKBMS_COMP(OodleNetwork1UDP_Decode)
    QUICKBMS_COMP(OodleNetwork1UDP_Encode)
    QUICKBMS_COMP(QCMP1)
    QUICKBMS_COMP(YKCMP)
    QUICKBMS_COMP(LZWAB)
    QUICKBMS_COMP(NCOMPRESS)
    QUICKBMS_COMP(SWZAP)
    QUICKBMS_COMP(MZX)
    QUICKBMS_COMP(LZRRV)
    QUICKBMS_COMP(BCM)
    QUICKBMS_COMP(ULZ)
    QUICKBMS_COMP(SLZ_ROF)
    QUICKBMS_COMP(LZ4X_NEW)
    QUICKBMS_COMP(COPY2)
    QUICKBMS_COMP(SLZ_03b)
    QUICKBMS_COMP(MPPC)
    QUICKBMS_COMP(MPPC_BIG)
    QUICKBMS_COMP(ALZSS)
    QUICKBMS_COMP(CLZ)
    QUICKBMS_COMP(GTC)
    QUICKBMS_COMP(ANCO)
    QUICKBMS_COMP(ANCO0)
    QUICKBMS_COMP(ANCO1)
    QUICKBMS_COMP(ANCO2)
    QUICKBMS_COMP(ANCO3)
    QUICKBMS_COMP(ANCO4)
    QUICKBMS_COMP(ANCO5)
    QUICKBMS_COMP(konami_lz77)
    QUICKBMS_COMP(vct_lzs)
    QUICKBMS_COMP(umesoft)
    QUICKBMS_COMP(systemaqua_catf)
    QUICKBMS_COMP(sogna)
    QUICKBMS_COMP(pac_ads)
    QUICKBMS_COMP(ail_lzs)
    QUICKBMS_COMP(agsi)
    QUICKBMS_COMP(foster_fa2)
    QUICKBMS_COMP(an21)
    QUICKBMS_COMP(arc_link)
    QUICKBMS_COMP(maika_bk)
    QUICKBMS_COMP(maika_mk2)
    QUICKBMS_COMP(propeller_mgr)
    QUICKBMS_COMP(qlie)
    QUICKBMS_COMP(avg32_seen)
    QUICKBMS_COMP(sas5_iar)
    QUICKBMS_COMP(seraphim_scn)
    QUICKBMS_COMP(ugos_det)
    QUICKBMS_COMP(aaru_fl4)
    QUICKBMS_COMP(inspire_ida)
    QUICKBMS_COMP(kurumi_mpk)
    QUICKBMS_COMP(dice_rlz)
    QUICKBMS_COMP(pulltop)
    QUICKBMS_COMP(vnsystem)
    QUICKBMS_COMP(QlzUnpack)
    QUICKBMS_COMP(umesoft_pk)
    QUICKBMS_COMP(tomcat_tcd)
    QUICKBMS_COMP(tail_pren)
    QUICKBMS_COMP(tail_crp0)
    QUICKBMS_COMP(tail_hp)
    QUICKBMS_COMP(tactics_arc)
    QUICKBMS_COMP(sviu_pkz)
    QUICKBMS_COMP(nekox_gpc)
    QUICKBMS_COMP(rec_arc)
    QUICKBMS_COMP(warc)
    QUICKBMS_COMP(warc10)
    QUICKBMS_COMP(warc_ylz)
    QUICKBMS_COMP(warc_huff)
    QUICKBMS_COMP(sh_him)
    QUICKBMS_COMP(pandora_pbx)
    QUICKBMS_COMP(origin_lz)
    QUICKBMS_COMP(origin_huffman)
    QUICKBMS_COMP(origin_rle)
    QUICKBMS_COMP(origin_alphav2)
    QUICKBMS_COMP(garbro_huffman)
    QUICKBMS_COMP(ankh_grp)
    QUICKBMS_COMP(ankh_hdj)
    QUICKBMS_COMP(caramelbox_arc3)
    QUICKBMS_COMP(caramelbox_arc4)
    QUICKBMS_COMP(circus_V1)
    QUICKBMS_COMP(circus_V2)
    QUICKBMS_COMP(circus_V3)
    QUICKBMS_COMP(cmvs_cpz)
    QUICKBMS_COMP(daisystem_pac)
    QUICKBMS_COMP(ethornell_bgi)
    QUICKBMS_COMP(fc01_mrg)
    QUICKBMS_COMP(fc01_mrg_quant)
    QUICKBMS_COMP(fc01_pak_lz)
    QUICKBMS_COMP(favorite_lzw)
    QUICKBMS_COMP(frontwing_rle)
    QUICKBMS_COMP(frontwing_huffman)
    QUICKBMS_COMP(g2_gcex)
    QUICKBMS_COMP(gss_arc)
    QUICKBMS_COMP(hypatia_mariel)
    QUICKBMS_COMP(interheart_fpk)
    QUICKBMS_COMP(kaguya_ari)
    QUICKBMS_COMP(kaguya_lin2)
    QUICKBMS_COMP(kaguya_link)
    QUICKBMS_COMP(kaguya_uf)
    QUICKBMS_COMP(kid_dat)
    QUICKBMS_COMP(lambda_lax)
    QUICKBMS_COMP(microvision_arc)
    QUICKBMS_COMP(moonhir_fpk)
    QUICKBMS_COMP(spack)
    QUICKBMS_COMP(azsys)
    QUICKBMS_COMP(dxlib)
    QUICKBMS_COMP(glibg)
    QUICKBMS_COMP(gamesystem_cmp)
    QUICKBMS_COMP(puremail)
    QUICKBMS_COMP(groover_pcg)
    QUICKBMS_COMP(mnp_mma)
    QUICKBMS_COMP(strikes_pck)
    QUICKBMS_COMP(SEGA_LZ77X)
    QUICKBMS_COMP(NEPTUNIA0)
    QUICKBMS_COMP(puff8)
    QUICKBMS_COMP(lzh8)
    QUICKBMS_COMP(romchu)
    QUICKBMS_COMP(okage)
    QUICKBMS_COMP(lzsd_of)
    QUICKBMS_COMP(lzsd_gfd)
    QUICKBMS_COMP(lzsd_gba2)
    QUICKBMS_COMP(pzz)
    QUICKBMS_COMP(SL01)

//#ifdef QUICKBMS_COMP_ENUM
        // nop
    QUICKBMS_COMP(NOP)
        // compressors
    QUICKBMS_COMP(NONE_COMPRESS)
//#endif

    QUICKBMS_COMP(ZLIB_COMPRESS)
    QUICKBMS_COMP(DEFLATE_COMPRESS)
    QUICKBMS_COMP(LZO1_COMPRESS)
    QUICKBMS_COMP(LZO1X_COMPRESS)
    QUICKBMS_COMP(LZO2A_COMPRESS)
    QUICKBMS_COMP(XMEMLZX_COMPRESS)
    QUICKBMS_COMP(BZIP2_COMPRESS)
    QUICKBMS_COMP(GZIP_COMPRESS)
    QUICKBMS_COMP(LZSS_COMPRESS)
    QUICKBMS_COMP(SFL_BLOCK_COMPRESS)
    QUICKBMS_COMP(SFL_RLE_COMPRESS)
    QUICKBMS_COMP(SFL_NULLS_COMPRESS)
    QUICKBMS_COMP(SFL_BITS_COMPRESS)
    QUICKBMS_COMP(LZF_COMPRESS)
    QUICKBMS_COMP(BRIEFLZ_COMPRESS)
    QUICKBMS_COMP(JCALG_COMPRESS)
    QUICKBMS_COMP(BCL_HUF_COMPRESS)
    QUICKBMS_COMP(BCL_LZ_COMPRESS)
    QUICKBMS_COMP(BCL_RICE_COMPRESS)
    QUICKBMS_COMP(BCL_RLE_COMPRESS)
    QUICKBMS_COMP(BCL_SF_COMPRESS)
    QUICKBMS_COMP(SZIP_COMPRESS)
    QUICKBMS_COMP(HUFFMANLIB_COMPRESS)
    QUICKBMS_COMP(LZMA_COMPRESS)
    QUICKBMS_COMP(LZMA_86HEAD_COMPRESS)
    QUICKBMS_COMP(LZMA_86DEC_COMPRESS)
    QUICKBMS_COMP(LZMA_86DECHEAD_COMPRESS)
    QUICKBMS_COMP(LZMA_EFS_COMPRESS)
    QUICKBMS_COMP(FALCOM_COMPRESS)
    QUICKBMS_COMP(KZIP_ZLIB_COMPRESS)
    QUICKBMS_COMP(KZIP_DEFLATE_COMPRESS)
    QUICKBMS_COMP(PRS_COMPRESS)
    QUICKBMS_COMP(RNC_COMPRESS)
    QUICKBMS_COMP(LZ4_COMPRESS)
    QUICKBMS_COMP(SFL_BLOCK_CHUNKED_COMPRESS)
    QUICKBMS_COMP(SNAPPY_COMPRESS)
    QUICKBMS_COMP(ZPAQ_COMPRESS)
    QUICKBMS_COMP(BLOSC_COMPRESS)
    QUICKBMS_COMP(GIPFELI_COMPRESS)
    QUICKBMS_COMP(YAPPY_COMPRESS)
    QUICKBMS_COMP(LZG_COMPRESS)
    QUICKBMS_COMP(DOBOZ_COMPRESS)
    QUICKBMS_COMP(NITROSDK_COMPRESS)
    QUICKBMS_COMP(HEX_COMPRESS)
    QUICKBMS_COMP(BASE64_COMPRESS)
    QUICKBMS_COMP(LZMA2_COMPRESS)
    QUICKBMS_COMP(LZMA2_86HEAD_COMPRESS)
    QUICKBMS_COMP(LZMA2_86DEC_COMPRESS)
    QUICKBMS_COMP(LZMA2_86DECHEAD_COMPRESS)
    QUICKBMS_COMP(LZMA2_EFS_COMPRESS)
    QUICKBMS_COMP(LZMA_0_COMPRESS)
    QUICKBMS_COMP(LZMA2_0_COMPRESS)
    QUICKBMS_COMP(STORMHUFF_COMPRESS)
    QUICKBMS_COMP(CT_HughesTransform_COMPRESS)
    QUICKBMS_COMP(CT_LZ77_COMPRESS)
    QUICKBMS_COMP(CT_ELSCoder_COMPRESS)
    QUICKBMS_COMP(CT_RefPack_COMPRESS)
    QUICKBMS_COMP(DK2_COMPRESS)
    QUICKBMS_COMP(QFS_COMPRESS)
    QUICKBMS_COMP(LZHUFXR_COMPRESS)
    QUICKBMS_COMP(FSE_COMPRESS)
    QUICKBMS_COMP(ZSTD_COMPRESS)
    QUICKBMS_COMP(DS_BLZ_COMPRESS)
    QUICKBMS_COMP(DS_HUF_COMPRESS)
    QUICKBMS_COMP(DS_LZE_COMPRESS)
    QUICKBMS_COMP(DS_LZS_COMPRESS)
    QUICKBMS_COMP(DS_LZX_COMPRESS)
    QUICKBMS_COMP(DS_RLE_COMPRESS)
    QUICKBMS_COMP(HEATSHRINK_COMPRESS)
    QUICKBMS_COMP(SMAZ_COMPRESS)
    QUICKBMS_COMP(LZFX_COMPRESS)
    QUICKBMS_COMP(PITHY_COMPRESS)
    QUICKBMS_COMP(ZLING_COMPRESS)
    QUICKBMS_COMP(DENSITY_COMPRESS)
    QUICKBMS_COMP(BSC_COMPRESS)
    QUICKBMS_COMP(SHOCO_COMPRESS)
    QUICKBMS_COMP(WFLZ_COMPRESS)
    QUICKBMS_COMP(FASTARI_COMPRESS)
    QUICKBMS_COMP(DICKY_COMPRESS)
    QUICKBMS_COMP(SQUISH_COMPRESS)
    QUICKBMS_COMP(LZHL_COMPRESS)
    QUICKBMS_COMP(LZHAM_COMPRESS)
    QUICKBMS_COMP(TRLE_COMPRESS)
    QUICKBMS_COMP(SRLE_COMPRESS)
    QUICKBMS_COMP(MRLE_COMPRESS)
    QUICKBMS_COMP(CPK_COMPRESS)
    QUICKBMS_COMP(LZRW1KH_COMPRESS)
    QUICKBMS_COMP(BPE_COMPRESS)
    QUICKBMS_COMP(NRV2b_COMPRESS)
    QUICKBMS_COMP(NRV2d_COMPRESS)
    QUICKBMS_COMP(NRV2e_COMPRESS)
    QUICKBMS_COMP(LZSS0_COMPRESS)
    QUICKBMS_COMP(CLZW_COMPRESS)
    QUICKBMS_COMP(QUICKLZ_COMPRESS)
    QUICKBMS_COMP(ZOPFLI_ZLIB_COMPRESS)
    QUICKBMS_COMP(ZOPFLI_DEFLATE_COMPRESS)
    QUICKBMS_COMP(PKWARE_DCL_COMPRESS)
    QUICKBMS_COMP(LZ5_COMPRESS)
    QUICKBMS_COMP(YALZ77_COMPRESS)
    QUICKBMS_COMP(SYNLZ1_COMPRESS)
    QUICKBMS_COMP(SYNLZ2_COMPRESS)
    QUICKBMS_COMP(PPMZ2_COMPRESS)
    QUICKBMS_COMP(EA_JDLZ_COMPRESS)
    QUICKBMS_COMP(OODLE_COMPRESS)
    QUICKBMS_COMP(LZFSE_COMPRESS)
    QUICKBMS_COMP(M99CODER_COMPRESS)
    QUICKBMS_COMP(LZ4X_COMPRESS)
    QUICKBMS_COMP(YUKE_BPE_COMPRESS)
    QUICKBMS_COMP(LZO1A_COMPRESS)
    QUICKBMS_COMP(LZO1B_COMPRESS)
    QUICKBMS_COMP(LZO1C_COMPRESS)
    QUICKBMS_COMP(LZO1F_COMPRESS)
    QUICKBMS_COMP(LZO1Y_COMPRESS)
    QUICKBMS_COMP(LZO1Z_COMPRESS)
    QUICKBMS_COMP(LIZARD_COMPRESS)
    QUICKBMS_COMP(LIBLZS_COMPRESS)
    QUICKBMS_COMP(PRS_8ING_COMPRESS)
    QUICKBMS_COMP(DIZZY_COMPRESS)
    QUICKBMS_COMP(LEVEL5_COMPRESS)
    QUICKBMS_COMP(BROTLI_COMPRESS)
    QUICKBMS_COMP(DRV3_SRD_COMPRESS)
    QUICKBMS_COMP(YAZ0_COMPRESS)
    QUICKBMS_COMP(BIZARRE_COMPRESS)
    QUICKBMS_COMP(BIZARRE_SKIP_COMPRESS)
    QUICKBMS_COMP(BLACKDESERT_COMPRESS)
    QUICKBMS_COMP(DR12AE_COMPRESS)
    QUICKBMS_COMP(EA_COMP_COMPRESS)
    QUICKBMS_COMP(LBALZSS_COMPRESS)
    QUICKBMS_COMP(MOHLZSS_COMPRESS)
    QUICKBMS_COMP(MOHRLE_COMPRESS)
    QUICKBMS_COMP(NISLZS_COMPRESS)
    QUICKBMS_COMP(QCMP1_COMPRESS)
    QUICKBMS_COMP(RFPK_COMPRESS)
    QUICKBMS_COMP(RLEW_COMPRESS)
    QUICKBMS_COMP(SAINT_SEYA_COMPRESS)
    QUICKBMS_COMP(SHREK_COMPRESS)
    QUICKBMS_COMP(SLZ_01_COMPRESS)
    QUICKBMS_COMP(SLZ_02_COMPRESS)
    QUICKBMS_COMP(SLZ_03_COMPRESS)
    QUICKBMS_COMP(UCLPACK_COMPRESS)
    QUICKBMS_COMP(SEGA_LZS2_COMPRESS)
    QUICKBMS_COMP(WOLF_COMPRESS)
    QUICKBMS_COMP(YAKUZA_COMPRESS)
    QUICKBMS_COMP(YKCMP_COMPRESS)
    QUICKBMS_COMP(LZWAB_COMPRESS)
    QUICKBMS_COMP(NCOMPRESS_COMPRESS)
    QUICKBMS_COMP(UNCOMPRESS_COMPRESS)
    QUICKBMS_COMP(LZ4X_NEW_COMPRESS)
    QUICKBMS_COMP(DRAGONBALLZ_COMPRESS)
    QUICKBMS_COMP(MPPC_COMPRESS)
    QUICKBMS_COMP(MPPC_BIG_COMPRESS)
    QUICKBMS_COMP(APLIB_COMPRESS)
    QUICKBMS_COMP(okage_COMPRESS)
    QUICKBMS_COMP(LZ4F_COMPRESS)
    QUICKBMS_COMP(LZ5F_COMPRESS)
    QUICKBMS_COMP(PPMDH_COMPRESS)
    QUICKBMS_COMP(PPMDI_COMPRESS)
    QUICKBMS_COMP(PPMDH_RAW_COMPRESS)
    QUICKBMS_COMP(PPMDI_RAW_COMPRESS)

//#ifdef QUICKBMS_COMP_ENUM
    // remember to put the _COMPRESS ones also in file.c for reimporting
        // nop
    QUICKBMS_COMP(ERROR)
//#endif



#ifdef QUICKBMS_COMP_ENUM
};
#endif

#ifdef QUICKBMS_COMP_LIST
    { NULL, -1 }
};
#endif

#undef QUICKBMS_COMP
