/*
    Copyright 2008,2009,2010 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl-2.0.txt
*/

#include <stdlib.h>
#ifdef WIN32
    #include <windows.h>
#else
    #include <sys/mman.h>
#endif
typedef unsigned char   u8;
typedef unsigned short  u16;
# ifndef __stdcall
#  define __stdcall __attribute__ ((__stdcall__))
# endif



int     molebox_ctx_size    = 104;  // the ctx is 104 bytes in this version of Molebox



// anti DEP limitation! if you apply VirtualAlloc on a static char
// it will cover also the rest of the page included other variables!
void *molebox_antidep_alloc(u8 *dump, int dumpsz) {
    int     pagesz;
    void    *ret;

    pagesz = (dumpsz + 4095) & (~4095); // useful for pages? mah

#ifdef WIN32
    ret = VirtualAlloc(
        NULL,
        pagesz,
        MEM_COMMIT | MEM_RESERVE,
        PAGE_EXECUTE_READWRITE);    // write for memcpy
#else
    ret = malloc(pagesz);
    mprotect(
        ret,
        pagesz,
        PROT_EXEC | PROT_WRITE);    // write for memcpy
#endif
    memcpy(ret, dump, dumpsz);
    return(ret);
}



void molebox_setkey(u8 *data, u8 *key) {   // I don't know what version of Molebox was used, anyway the code it's all at 16 bit
    static __stdcall void (*molebox_setkey_func)(u8 *, const u8 *) = NULL;
    static unsigned char  dump[] =
    "\x55\x8b\xec\x83\xec\x78\x53\x56\x8b\x75\x08\x57\x6a\x02\x89\x4d\xfc\x66\x8b\x06\x5b\x50\x03\xf3\xe8\x2d\x01\x00\x00\x66\x8b\x3e"
    "\x03\xf3\x89\x45\xf8\x8b\x4d\xfc\x66\x8b\x06\x03\xf3\x66\xf7\xd8\x89\x45\x08\x66\x8b\x06\x50\x03\xf3\x66\xf7\xdf\xe8\x09\x01\x00"
    "\x00\x66\x89\x45\xee\x66\x8b\x45\x08\x66\x89\x45\xec\x66\x8b\x45\xf8\x66\x89\x7d\xea\x8d\x7d\xe8\x66\x89\x45\xe8\xc7\x45\xf0\x07"
    "\x00\x00\x00\x66\x8b\x06\x66\x8b\x0c\x1e\x03\xf3\x2b\xfb\x03\xf3\x66\x89\x0f\x8b\x4d\xfc\x2b\xfb\x66\x89\x07\x66\x8b\x06\x50\x03"
    "\xf3\xe8\xc4\x00\x00\x00\x89\x45\xf8\x66\x8b\x06\x66\xf7\xd8\x03\xf3\x89\x45\xf4\x8b\x4d\xfc\x2b\xfb\x66\x8b\x06\x03\xf3\x66\xf7"
    "\xd8\x89\x45\x08\x66\x8b\x06\x50\x03\xf3\xe8\x9b\x00\x00\x00\x66\x89\x07\x66\x8b\x45\xf4\x2b\xfb\x66\x89\x07\x66\x8b\x45\x08\x2b"
    "\xfb\x66\x89\x07\x66\x8b\x45\xf8\x2b\xfb\xff\x4d\xf0\x66\x89\x07\x75\x91\x66\x8b\x06\x66\x8b\x0c\x1e\x03\xf3\x2b\xfb\x03\xf3\x66"
    "\x89\x0f\x8b\x4d\xfc\x2b\xfb\x66\x89\x07\x66\x8b\x06\x50\x03\xf3\xe8\x55\x00\x00\x00\x89\x45\xf8\x66\x8b\x06\x8b\x4d\xfc\x03\xf3"
    "\x66\xf7\xd8\x89\x45\xf4\x66\x8b\x06\x66\x8b\x76\x02\x2b\xfb\x66\xf7\xd8\x56\x89\x45\x08\xe8\x2f\x00\x00\x00\x66\x89\x07\x66\x8b"
    "\x45\x08\x2b\xfb\x6a\x1a\x59\x8d\x75\x88\x66\x89\x07\x66\x8b\x45\xf4\x2b\xfb\x66\x89\x07\x66\x8b\x45\xf8\x66\x89\x47\xfe\x8b\x7d"
    "\x0c\xf3\xa5\x5f\x5e\x5b\xc9\xc2\x08\x00\x55\x8b\xec\x51\x8b\x45\x08\x53\x56\x57\x6a\x01\x5b\x66\x3b\xc3\x76\x74\xb9\x01\x00\x01"
    "\x00\x0f\xb7\xf8\x8b\xc1\x99\xf7\xff\x89\x45\x08\x8b\xc1\x99\xf7\xff\x66\x3b\xd3\x74\x55\x8b\xc7\x0f\xb7\xca\x99\xf7\xf9\x8b\xf0"
    "\x8b\xc7\x0f\xaf\x75\x08\x99\xf7\xf9\x46\x89\x75\xfc\x66\x3b\xd3\x74\x33\x8b\xc1\x0f\xb7\xf2\x99\xf7\xfe\x8b\xf8\x8b\xc1\x99\x0f"
    "\xaf\x7d\xfc\xf7\xfe\x01\x7d\x08\x66\x3b\xd3\x74\x1e\x8b\xc6\x0f\xb7\xca\x99\xf7\xf9\x8b\xf8\x8b\xc6\x0f\xaf\x7d\x08\x99\xf7\xf9"
    "\x01\x7d\xfc\xeb\xc8\x66\x8b\x45\xfc\xeb\x05\x8b\xc3\x2b\x45\x08\x5f\x5e\x5b\xc9\xc2\x04\x00";
    int     i;
    u16     *in,
            *out;
    u8      tmp[molebox_ctx_size];

    if(!molebox_setkey_func) {
        molebox_setkey_func = molebox_antidep_alloc(dump, sizeof(dump));
    }

    out = (u16 *)tmp;
    in  = (u16 *)data;
    for(i = 0; i < 8; i++) {
        out[i] = (in[i] >> 8) | (in[i] << 8);
    }
    for(; i < (molebox_ctx_size/2); i++) {
        if(!(i & 7)) in = (out + i) - 8;
        out[i] = (in[(i + 1) & 7] << 9) | (in[(i + 2) & 7] >> 7);
    }
    molebox_setkey_func(tmp, key);
}



void molebox_decrypt(u8 *key, u8 *data, int datasz) {   // I don't know what version of Molebox was used, anyway the code it's all at 16 bit
    static __stdcall void (*molebox_decrypt_func)(u8 *, u8 *, const u8 *) = NULL;
    static unsigned char  dump[] =
    "\x55\x8b\xec\x83\xec\x0c\x8b\x45\x08\x53\x56\x57\x66\x8b\x08\x66\x8b\x50\x02\x83\xc0\x02\xc7\x45\xfc\x08\x00\x00\x00\x40\x40\x66"
    "\x8b\x18\x66\x8b\x40\x02\x66\x89\x45\x08\x33\xc0\x8a\xc5\x8a\xe1\x8b\xc8\x33\xc0\x8a\xc6\x8a\xe2\x8b\xd0\x33\xc0\x8a\xc7\x8a\xe3"
    "\x8b\xf8\x33\xc0\x8a\x45\x09\x8a\x65\x08\x89\x45\x08\x8b\x45\x10\xeb\x03\x8b\x4d\x10\x66\x8b\x30\x40\x40\x66\x85\xf6\x74\x2d\x66"
    "\x85\xc9\x74\x1e\x0f\xb7\xf6\x0f\xb7\xc9\x0f\xaf\xf1\x8b\xce\xc1\xe9\x10\x66\x3b\xf1\x1b\xdb\xf7\xdb\x2b\xd9\x03\xde\x89\x5d\x10"
    "\xeb\x12\x6a\x01\x59\x2b\xce\x89\x4d\x10\xeb\x08\x6a\x01\x5e\x2b\xf1\x89\x75\x10\x66\x8b\x08\x03\xd1\x40\x40\x66\x8b\x08\x03\xf9"
    "\x40\x40\x66\x8b\x08\x40\x40\x66\x85\xc9\x74\x30\x66\x83\x7d\x08\x00\x74\x1f\x0f\xb7\xf1\x0f\xb7\x4d\x08\x0f\xaf\xf1\x8b\xce\xc1"
    "\xe9\x10\x66\x3b\xf1\x1b\xdb\xf7\xdb\x2b\xd9\x03\xde\x89\x5d\x08\xeb\x13\x6a\x01\x5e\x2b\xf1\x89\x75\x08\xeb\x09\x6a\x01\x59\x2b"
    "\x4d\x08\x89\x4d\x08\x66\x8b\x08\x89\x7d\xf8\x33\x7d\x10\x40\x40\x66\x85\xc9\x74\x27\x66\x85\xff\x74\x1b\x0f\xb7\xf1\x0f\xb7\xcf"
    "\x0f\xaf\xf1\x8b\xce\xc1\xe9\x10\x66\x3b\xf1\x1b\xff\xf7\xdf\x2b\xf9\x03\xfe\xeb\x0e\x6a\x01\x5f\x2b\xf9\xeb\x07\x6a\x01\x59\x2b"
    "\xcf\x8b\xf9\x8b\x75\x08\x66\x8b\x08\x33\xf2\x89\x55\xf4\x03\xf7\x40\x40\x66\x85\xc9\x74\x27\x66\x85\xf6\x74\x1b\x0f\xb7\xd9\x0f"
    "\xb7\xce\x0f\xaf\xd9\x8b\xcb\xc1\xe9\x10\x66\x3b\xd9\x1b\xd2\xf7\xda\x2b\xd1\x03\xd3\xeb\x0c\x6a\x01\x5a\x2b\xd1\xeb\x05\x6a\x01"
    "\x5a\x2b\xd6\x31\x55\x10\x03\xfa\x31\x7d\x08\x33\x55\xf8\x33\x7d\xf4\xff\x4d\xfc\x0f\x85\xd8\xfe\xff\xff\x66\x8b\x08\x40\x40\x66"
    "\x85\xc9\x74\x2a\x66\x83\x7d\x10\x00\x74\x1c\x0f\xb7\xf1\x0f\xb7\x4d\x10\x0f\xaf\xf1\x8b\xce\xc1\xe9\x10\x66\x3b\xf1\x1b\xdb\xf7"
    "\xdb\x2b\xd9\x03\xde\xeb\x0d\x6a\x01\x5b\x2b\xd9\xeb\x06\x6a\x01\x5b\x2b\x5d\x10\x66\x8b\x08\x03\xf9\x40\x40\x89\x7d\x10\x66\x8b"
    "\x08\x66\x8b\x40\x02\x03\xd1\x66\x85\xc0\x74\x2a\x66\x83\x7d\x08\x00\x74\x1c\x0f\xb7\x4d\x08\x0f\xb7\xc0\x0f\xaf\xc1\x8b\xf0\xc1"
    "\xee\x10\x66\x3b\xc6\x1b\xc9\xf7\xd9\x2b\xce\x03\xc8\xeb\x0d\x6a\x01\x59\x2b\xc8\xeb\x06\x6a\x01\x59\x2b\x4d\x08\x8b\x75\x0c\x33"
    "\xc0\x8a\xc7\x5f\x8a\xe3\x66\x89\x06\x33\xc0\x8a\x45\x11\x83\xc6\x02\x8a\x65\x10\x66\x89\x06\x33\xc0\x46\x8a\xc6\x46\x8a\xe2\x66"
    "\x89\x06\x33\xc0\x8a\xc5\x8a\xe1\x66\x89\x46\x02\x5e\x5b\xc9\xc2\x0c\x00";
    int     rounds;

    if(!molebox_decrypt_func) {
        molebox_decrypt_func = molebox_antidep_alloc(dump, sizeof(dump));
    }

    for(rounds = datasz >> 3; rounds; rounds--) {
        molebox_decrypt_func(data, data, key);
        data += 8;
    }
}
